#ifndef __RT_LIB_RT_Feature_h__
#define __RT_LIB_RT_Feature_h__

#include <fire/private/prefix.h>
#include <typeinfo>

namespace FIRE_NAMESPACE {

class RT_Consumer;
class RT_FeatureImpl;

class RT_API RT_Feature
{
protected:
  RT_Feature( RT_FeatureImpl* impl );
public:
  virtual ~RT_Feature();

  bool enable( RT_Consumer& cons );
  bool disable( RT_Consumer& cons );
  bool is_active( const RT_Consumer& cons ) const;

  const std::type_info& feature_type() const;

protected:
  friend struct RT_ConsumerImpl;
  RT_FeatureImpl* m_feature_impl;
};

} //  namespace FIRE_NAMESPACE
#endif // __RT_LIB_RT_Feature_h__
