#ifndef __FIRE_BYTE_ORDER_H__
#define __FIRE_BYTE_ORDER_H__

#if defined(FIRE_UNALIGNED_ACCESS) || defined(FIRE_LITTLE_ENDIAN) || defined(FIRE_BIG_ENDIAN) || defined(FIRE_BYTE_ORDER) || defined(FIRE_64BIT) || defined(FIRE_32BIT)
#error "Conflict with FIRE_UNALIGNED_ACCESS macros"
#endif

#define FIRE_LITTLE_ENDIAN 1234
#define FIRE_BIG_ENDIAN    4321

#if defined(__sparc) || defined(__sparc__) || defined(__sparcv9)
#define FIRE_BYTE_ORDER FIRE_BIG_ENDIAN
#if defined (__sparcv9)
/* Sparc 64 bit systems */
#define FIRE_64BIT
#else
/* Sparc 32 bit systems */
#define FIRE_32BIT
#endif

#elif ((defined(WIN32) || defined(_WIN32)) && !defined(_WIN64)) \
  || defined(_M_IX86) || defined(__i386__) || defined (__i386)
/* Intel 32 bit systems */
#define FIRE_BYTE_ORDER FIRE_LITTLE_ENDIAN
#define FIRE_UNALIGNED_ACCESS
#define FIRE_32BIT

#elif defined(__x86_64) || defined (__x86__64__) || defined(_M_X64)
/* Intel 32 bit system with AMD 64bit extensions */
#define FIRE_BYTE_ORDER FIRE_LITTLE_ENDIAN
#define FIRE_UNALIGNED_ACCESS
#define FIRE_64BIT

#elif defined(__ia64) || defined (__ia64__) || defined (__IA64) || defined(_M_IA64)
/* Intel Itanium  */
/* TODO: Needs research to see if defining FIRE_UNALIGNED_ACCESS is faster*/
#define FIRE_BYTE_ORDER FIRE_LITTLE_ENDIAN
/* TODO: ia64/VMS needs different checks */
#define FIRE_64BIT
/* #define FIRE_UNALIGNED_ACCESS */

#elif defined(__alpha) || defined (__alpha__) || defined (__ALPHA)
/* DEC Alpha  */
#define FIRE_BYTE_ORDER FIRE_LITTLE_ENDIAN
#define FIRE_UNALIGNED_ACCESS
/* TODO: Alpha/VMS needs different checks */
#define FIRE_64BIT

#else
#error "Unknown architecture and/or compiler"
#endif

#endif
